#include <windows.h>
#include <stdio.h>
#define PATH_SIZE 32
#define TITLE_SIZE 32
#define DSCPLN_NUMBER 32
#define TOPICS_NUMBER 48
#define MENU_ABOUT 10
#define MENU_INFO 11
#define MENU_DISCIPLINE 20
#define CHILD_WINDOW 200
#define HTOPIC 300
#define HCHILDOK 4000
#define V_SPACE 25
#define TASK_SIZE 2048
#define QUESTION_SIZE 1024
#define QNumber 512
#define ANSWER_SIZE 512
#define MAIN_OK 10000
#define hVARIANT 10004
#define VarNumber 7
#define YMax Vertres-60
#define YStart 10
#define OKButtonHeight 30

LRESULT CALLBACK WndProc(HWND hWnd,UINT msg,
WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK ChildProc(HWND hwnd, UINT Message, WPARAM wparam,LPARAM lparam);
BOOL CreateMenuItem
	(HMENU hMenu,
	char* str,
	UINT uID,
	UINT wID,
	HMENU hSubMenu);

class SingleVisualEntry
{
public:
	SingleVisualEntry();
	int qNumber;
	RECT task;
	RECT variants;
	HWND hVariant[7];
	HWND hOK;
	bool visible;
};

class Screen
{
public:
	Screen();
	void HideAll(HWND hWnd);
	bool PlaceQuestion(HWND hWnd,HDC hDC,int ToInsert);
	void RemoveInvisible(HWND hWnd);
	void DrawTask(HWND hWnd, HDC hDC);
	SingleVisualEntry Entry[4];
	int CurrentPosition;
};

class TitlePath
{
public:
	char title[TITLE_SIZE];
	char path[PATH_SIZE];
	bool loaded;
	void ClearTitle();
};

class vrnt
{
public:
	bool loaded,correct;
	char text[ANSWER_SIZE];
};

class Q
{
public:
	Q();
	bool loaded, completed;
	int showed;
	char task[TASK_SIZE];
	vrnt variant[7];
};

struct QuestionToAnalyze
{
	int task_height;
	int variants_height;
};

void ChooseTopic(TitlePath Ds, HWND hWnd, HINSTANCE hInstance);
void LoadQuestions(TitlePath Topic);
void GetStat();
void UnloadTopic();
void UnloadQuestions();
int GetNextQuestion(int start);

TitlePath Dscpln[DSCPLN_NUMBER];
TitlePath Topic[TOPICS_NUMBER];
Q Question[QNumber];
HINSTANCE hInst;
char BasePath[]="Base\\";

int WINAPI WinMain(HINSTANCE hInstance,
HINSTANCE hPrevInstance,
LPSTR lpCmdLine, int iCmdShow)
{

const char szClassName[]="MainWindow";
WNDCLASSEX wc;
MSG msg;
HWND hWnd;
hInst=hInstance;

wc.cbSize=sizeof(wc);
wc.cbClsExtra=0;
wc.cbWndExtra=0;
wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;
wc.hCursor=LoadCursor(0,IDC_ARROW);
wc.hIcon=LoadIcon(hInstance,IDI_APPLICATION);
wc.hIconSm=LoadIcon(hInstance,IDI_APPLICATION);
wc.hInstance=hInstance;
wc.lpfnWndProc=WndProc;
wc.lpszClassName=szClassName;
wc.lpszMenuName=NULL;
wc.style=CS_HREDRAW | CS_VREDRAW;
RegisterClassEx(&wc);

HANDLE hFind;
WIN32_FIND_DATA FindFileData;
HANDLE hFile;
DWORD dwNumRead;
bool bWorking=1;
char Mask[]="*.txt";
char ToSearch[PATH_SIZE];
int DCount=0;

sprintf(ToSearch, "%s%s", BasePath, Mask);
hFind=FindFirstFile(ToSearch, &FindFileData);
sprintf(Dscpln[DCount].path, "%s%s", BasePath, FindFileData.cFileName);
hFile=CreateFile(
	Dscpln[DCount].path,
	GENERIC_READ,
	FILE_SHARE_READ,
	NULL,
	OPEN_EXISTING,
	FILE_ATTRIBUTE_NORMAL,
	NULL);
ReadFile(hFile, Dscpln[DCount].title, TITLE_SIZE, &dwNumRead,NULL);
Dscpln[DCount].ClearTitle();
Dscpln[DCount].loaded=1;
CloseHandle(hFile);
while (bWorking=FindNextFile(hFind, &FindFileData)!=0)
	{
	DCount++;
	sprintf(Dscpln[DCount].path, "%s%s", BasePath, FindFileData.cFileName);
	hFile=CreateFile(
		Dscpln[DCount].path,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL);
	ReadFile(hFile, Dscpln[DCount].title, TITLE_SIZE, &dwNumRead,NULL);
	Dscpln[DCount].ClearTitle();
	Dscpln[DCount].loaded=1;
	CloseHandle(hFile);
	}
	FindClose(hFind);

static HMENU hMainMenu;
static HMENU hDscplnMenu;
static HMENU hHelpMenu;

	hMainMenu = CreateMenu();
	hDscplnMenu = CreatePopupMenu();
	hHelpMenu = CreatePopupMenu();
	for (int i=0;i<=DCount;i++)
	{
        	CreateMenuItem(hDscplnMenu, Dscpln[i].title, 0, MENU_DISCIPLINE+i, NULL);
	}
	CreateMenuItem(hHelpMenu, "About", 1, MENU_ABOUT, NULL);
	CreateMenuItem(hHelpMenu, "Info", 1, MENU_INFO, NULL);
	CreateMenuItem(hMainMenu, "Disciplines", 0, 0, hDscplnMenu);
	CreateMenuItem(hMainMenu, "Help", 1, 0, hHelpMenu);

hWnd = CreateWindowEx
	(0,
	szClassName,
	"AskMe 2.0",
	WS_OVERLAPPEDWINDOW,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	(HWND) NULL,
	(HMENU) hMainMenu,
	hInstance,
	NULL);

ShowWindow(hWnd,SW_MAXIMIZE);
UpdateWindow(hWnd);

while (GetMessage(&msg,0,0,0))
{
	TranslateMessage(&msg);
	DispatchMessage(&msg);
}

return 0;
}

LRESULT CALLBACK WndProc
	(HWND hWnd,
	UINT msg,
	WPARAM wParam,
	LPARAM lParam)
{
HDC hDC;
PAINTSTRUCT ps;
int i,j;
static int QCurrent=0;
static Screen OnScreen;
HFONT hCorrect,hMissing,hExcessive;
HWND hwndCheck;
hCorrect=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
hMissing=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	1,			// italic attribute option
	1,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
hExcessive=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	400,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	1,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);

switch(msg)
{
case WM_CREATE:
{
}
break;

case WM_PAINT:
{
	hDC=BeginPaint(hWnd,&ps);
	OnScreen.DrawTask(hWnd,hDC);
	EndPaint(hWnd,&ps);
}
break;

case WM_COMMAND:
{
for(j=0;j<=DSCPLN_NUMBER;j++)
{
	if((LOWORD(wParam)==MENU_DISCIPLINE+j)&&(Dscpln[j].loaded))
	{
	UnloadTopic();
	ChooseTopic(Dscpln[j],hWnd, hInst);
	}
}

if (LOWORD(wParam)==MAIN_OK)
{
	static bool first=1;
	int kount=0;
	static bool ok=1;
	int hPosition=0;
	int count;
	LRESULT res;

	for(int m=0;m<QCurrent;m++)
	{
		for(count=0;count<7;count++)
		{
		if(Question[m].variant[count].loaded) hPosition+=4;
		}
	}
	for(kount=0;kount<7;kount++)
	{
	if(Question[QCurrent].variant[kount].loaded)
	{
		hwndCheck = GetDlgItem(hWnd, hVARIANT+hPosition+4*kount);
		if(first)
		{
		res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if((res == BST_CHECKED)&(Question[QCurrent].variant[kount].correct))
			{ok=0;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hCorrect, 1);}
		if((res == BST_CHECKED)&(!Question[QCurrent].variant[kount].correct))
			{ok=0;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hExcessive, 1);}
		if((res == BST_UNCHECKED)&(Question[QCurrent].variant[kount].correct))
			{ok=0;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hMissing, 1);}
		}
		else EnableWindow(hwndCheck,0);
	}
	}
	if(ok) {Question[QCurrent].completed=1;}

	if(!first)
	{
		ok=1;
		if(Question[QCurrent+1].loaded==0)
			{GetStat();
			OnScreen.HideAll(hWnd);
			OnScreen.RemoveInvisible(hWnd);
			QCurrent=-1;}
		QCurrent=GetNextQuestion(QCurrent);
		if(QCurrent==-1) {MessageBox(NULL,"Game over","Game over",MB_OK);}
		hDC=GetDC(hWnd);
		OnScreen.PlaceQuestion(hWnd,hDC,QCurrent);
		ReleaseDC(hWnd,hDC);
	}
	first=!first;
}
return -1;
}

case (WM_USER):
{
	OnScreen.HideAll(hWnd);
	OnScreen.RemoveInvisible(hWnd);
	QCurrent=0;
	hDC=GetDC(hWnd);
	OnScreen.PlaceQuestion(hWnd,hDC,QCurrent);
	ReleaseDC(hWnd,hDC);
	hDC=GetDC(hWnd);
	OnScreen.DrawTask(hWnd,hDC);
	ReleaseDC(hWnd,hDC);
	UpdateWindow(hWnd);
}
break;

case WM_DESTROY:
PostQuitMessage(0);
break;

default:
return DefWindowProc(hWnd,msg,wParam,lParam);
}

return 0;
}

LRESULT CALLBACK ChildProc
	(
	HWND hwnd,
	UINT Message,
	WPARAM wparam,
	LPARAM lparam
	)
{
HWND hParent;
int i=0;
char text[10];
switch (Message)
{

case WM_CREATE:
{
	hParent = GetWindow(hwnd,GW_OWNER);
	EnableWindow(hParent,0);
	EnableWindow(hwnd,1);
}
break;

case WM_COMMAND:
{
	LRESULT res;
	bool chosen=0;
	if(LOWORD(wparam)==HCHILDOK)
	{
	hParent = GetWindow(hwnd,GW_OWNER);
	for(i=0;i<TOPICS_NUMBER;i++)
	{
		if (Topic[i].loaded)
		{
		HWND hwndCheck = GetDlgItem(hwnd, 4*i+HTOPIC);
		res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res==BST_CHECKED) {UnloadQuestions();LoadQuestions(Topic[i]);chosen=1;}
		}
	}
	if(chosen) PostMessage(hParent,WM_USER,0,0);
	DestroyWindow(hwnd);
	}
return -1;
}
break;

case WM_DESTROY:
{
	hParent = GetWindow(hwnd,GW_OWNER);
	EnableWindow(hParent,1);
	ShowWindow(hParent,SW_MAXIMIZE);
	UpdateWindow(hParent);
	return 0;
}
break;

default:
	return DefWindowProc(hwnd,Message,wparam,lparam);
}
}

void TitlePath::ClearTitle()
{
bool Clear=0;
for (int i=0;i<TITLE_SIZE;i++)
	{
	if ((title[i]==(char)13)&(!Clear)) Clear=1;
	if (Clear) title[i]=NULL;
	}
}

void ChooseTopic(TitlePath Discipline, HWND hWnd, HINSTANCE hInstance)
{
bool title=0;
bool path=0;
int i=0;
char ch;
DWORD NumRead;
HANDLE hFile;
int TCount=-1;
int k=0;

hFile=CreateFile(
	Discipline.path,
	GENERIC_READ,
	FILE_SHARE_READ,
	NULL,
	OPEN_EXISTING,
	FILE_ATTRIBUTE_NORMAL,
	NULL);
do
{
	ReadFile(hFile,&ch,1,&NumRead,NULL);
	if(ch==(char)9) {title=true;TCount++;Topic[TCount].loaded=1;}
	if(ch=='\"') {title=!title;path=!path;i=0;}
	if(
		(title)&
		(ch!=(char)9)&
		(ch!=(char)10)&
		(ch!=(char)13)&
		(ch!='\"')
	)
	{Topic[TCount].title[i]=ch;i++;}
	if(
		(path)&
		(ch!='\"')
	)
	{Topic[TCount].path[i]=ch;i++;}
}
while(NumRead!=0);
CloseHandle(hFile);
for(i=0;i<=TCount;i++)
{
char tmp[PATH_SIZE];
sprintf(tmp,"%s%s",BasePath,Topic[i].path);
strcpy(Topic[i].path,tmp);
}


	HWND child;
	WNDCLASS w;
	memset(&w,0,sizeof(WNDCLASS));
	w.lpfnWndProc = ChildProc;
	w.hInstance = hInstance;
	w.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
	w.lpszClassName = "ChildWClass";
	w.hCursor=LoadCursor(NULL,IDC_CROSS); 
	RegisterClass(&w);

HDC hDCScreen = GetDC(NULL);
int Horres = GetDeviceCaps(hDCScreen, HORZRES);
int Vertres = GetDeviceCaps(hDCScreen, VERTRES);
int left,top,width,height;
left=Horres/2-300;
top=(Vertres/2-((TCount-(TCount+2)%2)*(V_SPACE/2))/2)/4;
width=600;
height=(TCount-(TCount+2)%2)*(V_SPACE/2)+100;
	child=CreateWindowEx(
		0,
		"ChildWClass",
		"Dialog",
		WS_OVERLAPPEDWINDOW,
		left,
		top,
		width,
		height,
		hWnd,
		NULL,
		hInstance,
		NULL);
	for(k=0;k<TOPICS_NUMBER;k++)
	{
	if(Topic[k].loaded)
	{
	CreateWindow(
		"button",
		Topic[k].title,
		WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON,
		10+300*((k+2)%2),
		10+(k-(k+2)%2)*(V_SPACE/2),
		300,
		30,
		child,
		(HMENU)(HTOPIC+4*k),
		hInstance,
		NULL);
	}
	}
	CreateWindow(
		"button",
		"OK",
		WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
	        10,
		40+(TCount-(TCount+2)%2)*(V_SPACE/2),
		80,
		30,
		child,
		(HMENU)HCHILDOK,
		hInstance,
		NULL);
	ShowWindow(child,SW_SHOW);
	UpdateWindow(child);
}

void UnloadTopic()
{
int i,j;
for(i=0;i<TOPICS_NUMBER;i++)
{
	Topic[i].loaded=0;
	for(j=0;j<TITLE_SIZE;j++) Topic[i].title[j]=NULL;
	for(j=0;j<PATH_SIZE;j++) Topic[i].path[j]=NULL;
}
}

void LoadQuestions(TitlePath Topic)
{
DWORD NumRead;
HANDLE hFile;
char ch;
bool new_str=1,istask,visible;
int i,j;
int QCount=-1;

hFile=CreateFile(
	Topic.path,
	GENERIC_READ,
	FILE_SHARE_READ,
	NULL,
	OPEN_EXISTING,
	FILE_ATTRIBUTE_NORMAL,
	NULL);
do
{
	visible=1;
	ReadFile(hFile,&ch,1,&NumRead,NULL);
	if(new_str)
	{
		if (ch==(char)9) {istask=0;j++;Question[QCount].variant[j].loaded=1;i=0;}
		else {istask=true;QCount++;Question[QCount].loaded=1;j=-1;i=0;}
		new_str=false;
	}
	if(ch==(char)10) {new_str=true;}
	if(ch==(char)13|(ch==(char)10)){visible=0;}
	if((istask)&(visible)) {Question[QCount].task[i]=ch;i++;}
	else
	{
		if((ch=='+')&(i==0)){Question[QCount].variant[j].correct=1;visible=0;}
		if((ch=='-')&(i==0)){Question[QCount].variant[j].correct=0;visible=0;}
		if((ch==(char)9)|(ch==(char)10)|(ch==(char)13)){visible=0;}
		if(visible){Question[QCount].variant[j].text[i]=ch;i++;}
	}
}
while(NumRead!=0);
}

void UnloadQuestions()
{
int i,j,k;
for(i=0;i<QNumber;i++)
{
Question[i].loaded=0;
Question[i].completed=0;
Question[i].showed=0;
for(j=0;j<TASK_SIZE;j++) Question[i].task[j]=NULL;
for(j=0;j<7;j++)
{
	Question[i].variant[j].loaded=0;
	Question[i].variant[j].correct=0;
	for(k=0;k<ANSWER_SIZE;k++) Question[i].variant[j].text[k]=NULL;
}
}
}

BOOL CreateMenuItem
	(
	HMENU hMenu,
	char* str,
	UINT uID,
	UINT wID,
	HMENU hSubMenu
	)
{
    MENUITEMINFO mi;
    mi.cbSize = sizeof(MENUITEMINFO);
    mi.fMask = MIIM_STATE|MIIM_TYPE|MIIM_SUBMENU|MIIM_ID;
    mi.fType = MFT_STRING;
    mi.fState = MFS_ENABLED;
    mi.dwTypeData = str;
    mi.cch = sizeof(str);
    mi.wID = wID;
    mi.hSubMenu = hSubMenu;
    return InsertMenuItem(hMenu, uID, FALSE, &mi);
}

SingleVisualEntry::SingleVisualEntry()
{
	for(int i=0;i<7;i++) hVariant[i]=NULL;
	hOK=NULL;
	qNumber=-1;
	task.left=0;
	task.right=0;
	task.top=0;
	task.bottom=0;
	variants.left=0;
	variants.right=0;
	variants.top=0;
	variants.bottom=0;
	visible=0;
}

Screen::Screen()
{
	CurrentPosition=-1;
}

bool Screen::PlaceQuestion(HWND hWnd,HDC hDC,int ToInsert)
{
static int handle=hVARIANT-4;

RECT tmp;
int TaskHeight,VariantsHeight;
int i,j,VarCount=0;
int hPosition=0;
HDC hDCScreen;
int Horres,Vertres;

if(ToInsert==-1) return 0;

hDCScreen = GetDC(NULL);
Horres = GetDeviceCaps(hDCScreen, HORZRES);
Vertres = GetDeviceCaps(hDCScreen, VERTRES);
ReleaseDC(NULL, hDCScreen);
tmp.left=0;
tmp.right=Horres;
tmp.top=0;
tmp.bottom=30;
DrawText(hDC, Question[ToInsert].task, strlen(Question[ToInsert].task), &tmp, DT_CALCRECT|DT_WORDBREAK);
TaskHeight=tmp.bottom-tmp.top;
VariantsHeight=0;
for(i=0;i<7;i++)
{
if(Question[ToInsert].variant[i].loaded)
	{
	VariantsHeight+=30;
	}
}

CurrentPosition++;
if(CurrentPosition==4) CurrentPosition=0;

if(CurrentPosition!=0)
{
if(
	(Entry[CurrentPosition-1].variants.bottom
	+TaskHeight
	+VariantsHeight
	+OKButtonHeight)
	>YMax)
	CurrentPosition=0;
}

Entry[CurrentPosition].visible=0;
RemoveInvisible(hWnd);

if(CurrentPosition==0) Entry[CurrentPosition].task.top=YStart;
else Entry[CurrentPosition].task.top=Entry[CurrentPosition-1].variants.bottom;

Entry[CurrentPosition].task.bottom=Entry[CurrentPosition].task.top+TaskHeight;
Entry[CurrentPosition].variants.top=Entry[CurrentPosition].task.bottom;
Entry[CurrentPosition].variants.bottom=Entry[CurrentPosition].variants.top+VariantsHeight;

Entry[CurrentPosition].task.left=Entry[CurrentPosition].variants.left=0;
Entry[CurrentPosition].task.right=Entry[CurrentPosition].variants.right=1024;

Entry[CurrentPosition].visible=1;
Entry[CurrentPosition].qNumber=ToInsert;

if(CurrentPosition!=3)
{
if(
	(Entry[CurrentPosition].variants.bottom
	+OKButtonHeight)
	>Entry[CurrentPosition+1].task.top)
	Entry[CurrentPosition+1].visible=0;
}
RemoveInvisible(hWnd);

DrawText
	(hDC,
	Question[ToInsert].task,
	strlen(Question[ToInsert].task),
	&Entry[CurrentPosition].task,
	DT_WORDBREAK);

for(i=0;i<VarNumber;i++)
{
	if(Question[Entry[CurrentPosition].qNumber].variant[i].loaded)
	{

		if(Question[Entry[CurrentPosition].qNumber].showed!=0)
		{
		hPosition=0;
		for(int m=0;m<Entry[CurrentPosition].qNumber;m++)
		{
			for(j=0;j<7;j++)
				{if(Question[m].variant[j].loaded) hPosition+=4;}
		}
		handle=hVARIANT-4+hPosition+4*VarCount;
		}

	handle+=4;
	Entry[CurrentPosition].hVariant[i]=
		CreateWindow
		("button",
		Question[Entry[CurrentPosition].qNumber].variant[i].text,
		WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX|BS_MULTILINE,
		Entry[CurrentPosition].variants.left,
		Entry[CurrentPosition].variants.top+30*i,
		1024,
		30,
		hWnd,
		(HMENU)handle,
		hInst,
		NULL);
	VarCount++;
	}
}

Entry[CurrentPosition].hOK=CreateWindow(
	"button",
	"OK",
	WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
	Entry[CurrentPosition].variants.left,
	Entry[CurrentPosition].variants.top+30*VarCount,
	800,
	30,
	hWnd,
	(HMENU)MAIN_OK,
	hInst,
	NULL);
Question[Entry[CurrentPosition].qNumber].showed++;
return 1;
}

void Screen::RemoveInvisible(HWND hWnd)
{
int i,j;
for(j=0;j<4;j++)
{
if(!Entry[j].visible)
{
	InvalidateRect(hWnd, &Entry[j].task,1);
	for(i=0;i<7;i++)
	{
		if(Question[Entry[j].qNumber].variant[i].loaded)
		{
		DestroyWindow(Entry[j].hVariant[i]);
		}
	}
}
if(j!=CurrentPosition) DestroyWindow(Entry[j].hOK);
UpdateWindow(hWnd);
}
}

void Screen::DrawTask(HWND hWnd,HDC hDC)
{
int i;
for(i=0;i<4;i++)
{
if(Entry[i].visible)
DrawText(hDC, Question[Entry[i].qNumber].task, strlen(Question[Entry[i].qNumber].task), &Entry[i].task, DT_WORDBREAK);
}
}

Q::Q()
{
loaded=0;
showed=0;
completed=0;
}

void Screen::HideAll(HWND hWnd)
{
for(int i=0;i<4;i++)
	{
	Entry[i].visible=0;
	CurrentPosition=-1;
	}
}

void GetStat()
{
int i;
int total=0;
int correct=0;
float procent;
char result[64];
for(i=0;i<QNumber;i++)
{
if(Question[i].loaded)
{
total++;
	{
	if(Question[i].completed) correct++;
	}
}
}
procent=correct;
procent=(procent/total)*100;
sprintf(result,"Completed - %d, total - %d, (%f %) !!!",correct, total, procent);
MessageBox(NULL,result,"Statistics",MB_OK);
}

int GetNextQuestion(int start)
{
int i;
for(i=(start+1);i<QNumber;i++)
	{
	if(Question[i].completed==0) return i;
	}
return -1;
}
